/* make a random instance for weighted majority (voting) game */

#ifndef _powic_rnd_
#define _powic_rnd_

#define VEC_VAL_INT
#include"stdlib2.c"

int main(int argc, char *argv[]){
  int i, n, w, *h, s, base=1000000;  // 
  VEC p = INIT_VEC;
  
  if ( argc < 3 ) error ("powic_rnd UpP [num] [ave.weight]\n\
 generate instance with [num] players, with average weight [ave.weight]\n\
 U:uniform random, p:scale free; 1/x, P:power law distribution; 1/x^2\n", EXIT);

  n = atoi(argv[2]);  //  #players
  w = atoi(argv[3]);  //  #ave. weight of players
  calloc2 (h, n, EXIT);   //  weight of each player
  ARY_FILL (h, 0, n, 1);
  
  FLOOP (i, 0, n){   // compute the size of partition array
    s = base; if ( argv[1][0] == 'p' ) s = (i+1); else if ( argv[1][0] == 'P' ) s = (i+1)*(i+1); 
    s = base/s; for ( ; s>0 ; s--) ARY_INSZ (p, i, EXIT);
  }

  FLOOP (i, 0, n*w-n) h[ p.v[ rand() % p.t ]]++;  // simulate the distribution

  FLOOP (i, 0, n) printf ("%d ", h[i]);   // compute the size of partition array
  printf ("\n");

  return (0);
}

#endif

